<template>
  <div
    :style="{width:props.dimensions.width*props.ratioWidth+'px',height:props.dimensions.height*props.ratioHeight+'px'}">
    <NodeResizer @resizeEnd="(e) => $emit('resize', e)" color="#fff" v-if="!props.isView && !props.isHideHandle && props.selected" @resize="resize" />

    <div class="custom-node"
         :style="{width:props.dimensions.width*props.ratioWidth+'px',height:props.dimensions.height*props.ratioHeight+'px',pointerEvents:props.isView?'auto': 'none'}">
      <el-button :type="isErr ? 'danger':'primary'"
                 :style="{width:props.dimensions.width  +'px',height:props.dimensions.height+'px'}"
                 :icon="Connection">设备运行数量
      </el-button>
      <span style="color:#fff">
      </span>
    </div>
    <Handle v-if="!props.isView" :id="`${props.id}.-t`" type="target" :position="Position.Left" />
    <Handle v-if="!props.isView" :id="`${props.id}.-s`" type="source" :position="Position.Right" />
  </div>
</template>
<script setup>
import { defineEmits, defineProps, ref } from 'vue';
import { NodeResizer } from '@vue-flow/node-resizer';
import { Connection } from '@element-plus/icons-vue';
import { Handle, Position } from '@vue-flow/core';
import axios from 'axios';
import request from '@/utils/request';
import { options } from '../../tool.js';

const isErr = ref(false);

const props = defineProps({
  ratioWidth: {
    type: Number,
    required: false,
    default: 1
  },
  ratioHeight: {
    type: Number,
    required: false,
    default: 1
  },
  isView: {
    type: Boolean,
    required: false
  },
  inputData: {
    type: Object,
    required: false
  },
  id: {
    type: String,
    required: true
  },
  isHideHandle: {
    type: Boolean,
    required: false
  },
  selected: {
    type: Boolean,
    required: false
  },
  data: {
    type: Object,
    required: true
  },
  dimensions: {
    type: Object,
    required: true
  }
});
const service = axios.create({
  baseURL: 'http://localhost:3000',
  timeout: 10000
});
const getOutputData = () => {
  (options.isD ? request : service)({
    method: 'post',
    url: '/test/getDevice',
    data: props.inputData
  }).then(res => {
    isErr.value = false;
    let data = (options.isD ? res : res.data);
    props.data.outputData = {
      time: data?.data?.map(e => e.time),
      value: data?.data?.map(e => e.value)
    };
  }).catch(e => {
    isErr.value = true;
    console.log(e);
  });
};

onMounted(() => {
  getOutputData();
});

let interval = setInterval(() => {
  getOutputData();
}, 1000);

onBeforeUnmount(() => {
  clearInterval(interval);
  interval = null;
});
const emit = defineEmits(['resize']);
const resize = (e) => {
  emit('resize', e, props.id);
};
</script>
<style scoped>
.custom-node {
  width: 100%;
  height: 100%;
}

</style>
